#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Windows.Forms;
using HeuristicLab.MainForm;
using HeuristicLab.Clients.Common;
using HeuristicLab.Clients.OKB.OKBAdmin;
using System.ComponentModel;
using System.Collections.Generic;

namespace HeuristicLab.Clients.OKB {
  [View("OKB Administration")]
  public partial class AdministrationView : HeuristicLab.MainForm.WindowsForms.View {
    public AdministrationView() {
      InitializeComponent();
    }

    private void refreshButton_Click(object sender, System.EventArgs e) {
      IAdminService adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>();
      algorithmClassBindingSource.DataSource = adminService.GetAlgorithmClasses();
    }

    private void saveButton_Click(object sender, System.EventArgs e) {
      IAdminService adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>();
      adminService.UpdateAlgorithmClasses((List<AlgorithmClass>)algorithmClassBindingSource.DataSource);
    }

    private void dataGridView1_ColumnHeaderMouseClick(object sender, DataGridViewCellMouseEventArgs e) {
      if (dataGridView1.Columns[e.ColumnIndex].HeaderCell.SortGlyphDirection == SortOrder.None) {
        dataGridView1.Columns[e.ColumnIndex].HeaderCell.SortGlyphDirection = SortOrder.Ascending;
        dataGridView1.Sort(dataGridView1.Columns[e.ColumnIndex], ListSortDirection.Ascending);
      } else if (dataGridView1.Columns[e.ColumnIndex].HeaderCell.SortGlyphDirection == SortOrder.Ascending) {
        dataGridView1.Columns[e.ColumnIndex].HeaderCell.SortGlyphDirection = SortOrder.Descending;
        dataGridView1.Sort(dataGridView1.Columns[e.ColumnIndex], ListSortDirection.Descending);
      } else {
        dataGridView1.Columns[e.ColumnIndex].HeaderCell.SortGlyphDirection = SortOrder.Ascending;
        dataGridView1.Sort(dataGridView1.Columns[e.ColumnIndex], ListSortDirection.Ascending);
      }
    }
  }
}
